﻿Imports DevComponents.DotNetBar
Imports DotNetUtils
Public Class Form1
    'Declare global "openpath"
    Dim OpenPath As String
    Dim u As New vbUtils
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Read the config file here. Set some intial values
        OpenPath = ""

        'Open with mode
        If My.Application.CommandLineArgs.Count > 0 Then
            Dim pathname As String = My.Application.CommandLineArgs(0)
            Dim r As IO.StreamReader
            Try
                r = New IO.StreamReader(pathname)
                While (r.Peek() > -1)
                    TextBox1.AppendText(r.ReadLine & Environment.NewLine)
                End While
                r.Close()
            Catch ex As Exception
            End Try

            OpenPath = pathname
            Me.Text = "Notepad" & " - " & pathname
            TextBox1.Select(0, 0)
        Else
            'Make sure another instance isn't open. If it is, it will attempt to open the temp file generated by the autosave function.
            If u.ProcessRunning("Notepad.NET") = False Then
                'Check for any previous backups and offer to open them.
                Dim path As String = (My.Computer.FileSystem.SpecialDirectories.Temp & "\notepad_backup.tmp")
                If FileIO.FileSystem.FileExists(path) = True Then
                    Dim reply As DialogResult = MessageBoxEx.Show("It appears that Notepad failed to close correctly and unsaved changes to your file may have been lost." & Environment.NewLine & "Would you like to recover and open your most recent file?", "Unsaved file recovered.", _
                      MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
                    If reply = DialogResult.Yes Then
                        '
                        'Set the open path
                        OpenPath = path
                        Me.Text = "Notepad" & " - " & path

                        'Clear the previous text
                        TextBox1.Text = ""

                        'Write the text file
                        Dim r As IO.StreamReader
                        Try
                            r = New IO.StreamReader(path)
                            While (r.Peek() > -1)
                                TextBox1.AppendText(r.ReadLine & Environment.NewLine)
                            End While
                            r.Close()
                        Catch ex As Exception
                        End Try
                    End If
                End If
            End If
        End If

            'Disable saving until something has changed
            btnSave.Enabled = False

            'Check if type is htm or html ~ display browser menu
        If OpenPath.EndsWith(".html") Or OpenPath.EndsWith(".htm") Or OpenPath.EndsWith(".shtml") Then
            btnBrowser.Visible = True
            btnIE.Visible = True
            If My.Computer.FileSystem.FileExists(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Mozilla Firefox\firefox.exe") Then
                btnFF.Visible = True
            End If
            If My.Computer.FileSystem.FileExists(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Safari\Safari.exe") Then
                btnAS.Visible = True
            End If
            If My.Computer.FileSystem.FileExists(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Opera\opera.exe") Then
                btnOP.Visible = True
            End If
            If My.Computer.FileSystem.FileExists(System.Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) & "\Google\Chrome\Application\chrome.exe") Then
                btnGC.Visible = True
            End If
        End If

        'Enable the autosaving timer
        Timer1.Enabled = True

    End Sub
    Private Sub form1_closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        If btnSave.Enabled = True Then
            Dim reply As DialogResult = MessageBoxEx.Show("You have unsaved changes to your file." & Environment.NewLine & "Would you like to save them before closing?", "Unsaved Changes", _
              MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
            If reply = DialogResult.Yes Then
                'Check if the file has been previously saved. If not, use Save As command instead.
                If OpenPath = "" Then
                    btnSaveAs.PerformClick()
                    btnSave.Enabled = False
                    Exit Sub
                End If

                'It has been saved before. Let's update that file by writing a stream :)
                Dim TargetFile As IO.StreamWriter
                Try
                    My.Computer.FileSystem.DeleteFile(OpenPath)
                    TargetFile = New IO.StreamWriter(OpenPath, True)
                Catch
                    MessageBoxEx.Show("Error opening " & OpenPath)
                    Exit Sub
                End Try
                Try
                    TargetFile.Write(TextBox1.Text)
                    '  TargetFile.WriteLine()
                Catch
                    MessageBoxEx.Show("You do not have permission to overwrite this text file.")
                End Try
                TargetFile.Close()
            ElseIf reply = DialogResult.No Then
                Exit Sub
            Else
                e.Cancel = True
                Exit Sub
            End If

        End If


        Dim tempfile As String = My.Computer.FileSystem.SpecialDirectories.Temp & "\notepad_backup.tmp"
        'Delete the previous temp file
        Try
            My.Computer.FileSystem.DeleteFile(tempfile)
        Catch ex As Exception
        End Try
    End Sub
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        'This handles the keyboard shortcuts used by the interface.
        If e.KeyCode = Keys.N AndAlso e.Control Then
            btnNew.PerformClick()
        ElseIf e.KeyCode = Keys.S AndAlso e.Control Then
            btnSave.PerformClick()
        ElseIf e.KeyCode = Keys.A AndAlso e.Control Then
            TextBox1.SelectAll()
        ElseIf e.KeyCode = Keys.R AndAlso e.Control Then
            frmReplace.ShowDialog()
        ElseIf e.KeyCode = Keys.T AndAlso e.Control Then
            AlwaysOnTop.PerformClick()
        ElseIf e.KeyCode = Keys.F5 Then
            TextBox1.AppendText(TimeOfDay)
        End If
    End Sub

    Private Sub ToolStripButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNew.Click
        Dim aName As String
        Dim aPath As String
        'Make notepad location aware for "new" option.
        aName = _
          System.Reflection.Assembly.GetExecutingAssembly. _
          GetModules()(0).FullyQualifiedName
        aPath = System.IO.Path.GetDirectoryName(aName)
        Process.Start(aName)
    End Sub

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
        Me.Cursor = Cursors.WaitCursor
        Timer1.Enabled = False
        'Open the dialog
        Dim fdlg As OpenFileDialog = New OpenFileDialog()
        fdlg.Title = "Open"
        fdlg.Filter = "All files (*.*)|*.*|All files (*.*)|*.*"
        fdlg.FilterIndex = 2
        fdlg.RestoreDirectory = True
        ' fdlg.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        If fdlg.ShowDialog() = DialogResult.OK Then
            'Set the open path
            OpenPath = fdlg.FileName
            Me.Text = "Notepad" & " - " & fdlg.FileName

            'Clear the previous text
            TextBox1.Text = ""

            'Write the text file
            Dim FS As IO.FileStream
            Try
                FS = fdlg.OpenFile()
            Catch
                MessageBoxEx.Show("Error opening " & fdlg.FileName)
                Exit Sub
            End Try
            Dim TextData(1025) As Byte
            Dim BytesRead As Integer
            Dim I As Integer
            Dim NewText As String
            Dim line_read_count As Integer = 0
            Do
                Try
                    BytesRead = FS.Read(TextData, 1, 1024)
                    NewText = ""
                    For I = 1 To BytesRead
                        NewText = NewText & Chr(TextData(I))
                    Next
                    TextBox1.AppendText(NewText)
                Catch ex As Exception
                End Try
                line_read_count = line_read_count + 1
                If ForceRefresh.Checked = True Then
                    If line_read_count > 500 Then
                        Application.DoEvents()
                        line_read_count = 0
                    End If
                End If
            Loop While (BytesRead <> 0)
            FS.Close()
            btnSave.Enabled = True
        Else
            Exit Sub
        End If

        'Check if type is htm or html ~ display browser menu
        If OpenPath.EndsWith(".html") Or OpenPath.EndsWith(".htm") Or OpenPath.EndsWith(".shtml") Then
            btnBrowser.Visible = True
            btnIE.Visible = True
            If My.Computer.FileSystem.FileExists(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Mozilla Firefox\firefox.exe") Then
                btnFF.Visible = True
            End If
            If My.Computer.FileSystem.FileExists(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Safari\Safari.exe") Then
                btnAS.Visible = True
            End If
            If My.Computer.FileSystem.FileExists(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Opera\opera.exe") Then
                btnOP.Visible = True
            End If
            If My.Computer.FileSystem.FileExists(System.Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) & "\Google\Chrome\Application\chrome.exe") Then
                btnGC.Visible = True
            End If
        End If
        Timer1.Enabled = True
        Me.Cursor = Cursors.Default
    End Sub
    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        Me.Cursor = Cursors.WaitCursor

        'Check if the file has been previously saved. If not, use Save As command instead.
        If OpenPath = "" Then
            btnSaveAs.PerformClick()
            btnSave.Enabled = False
            Exit Sub
        End If

        'It has been saved before. Let's update that file by writing a stream :)
        Dim TargetFile As IO.StreamWriter
        Try
            My.Computer.FileSystem.DeleteFile(OpenPath)
            TargetFile = New IO.StreamWriter(OpenPath, True)
        Catch
            MessageBoxEx.Show("Error opening " & OpenPath)
            Exit Sub
        End Try
        Try
            TargetFile.Write(TextBox1.Text)
            '  TargetFile.WriteLine()
        Catch
            MessageBoxEx.Show("You do not have permission to overwrite this text file.")
        End Try
        TargetFile.Close()

        'Make the save button disabled.
        btnSave.Enabled = False
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Call save_temp_file()
    End Sub

    Private Sub btnSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveAs.Click
        Me.Cursor = Cursors.WaitCursor
        Dim saveFileDialog1 As New SaveFileDialog()
        saveFileDialog1.Filter = "Text Files (*.txt)|*.txt"
        saveFileDialog1.FileName = "Untitled"
        saveFileDialog1.FilterIndex = 2 : saveFileDialog1.RestoreDirectory = True
        If saveFileDialog1.ShowDialog() = DialogResult.OK Then
            System.IO.File.WriteAllText(saveFileDialog1.FileName, TextBox1.Text)
            btnSave.Enabled = False
            OpenPath = saveFileDialog1.FileName
            Me.Text = "Notepad" & " - " & saveFileDialog1.FileName
        Else
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        If TextBox1.Text = "" Then
            btnSave.Enabled = False
        Else
            btnSave.Enabled = True
        End If
    End Sub

    Private Sub ConvertToBase64ToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConvertToBase64ToolStripMenuItem.Click
        Dim bytes() As Byte = System.Text.Encoding.UTF8.GetBytes(TextBox1.Text)
        TextBox1.Text = (Convert.ToBase64String(bytes))
    End Sub

    Private Sub ConvertBase64ToTextToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConvertBase64ToTextToolStripMenuItem.Click
        Dim b As Byte() = Convert.FromBase64String(TextBox1.Text)
        TextBox1.Text = System.Text.Encoding.UTF8.GetString(b)
    End Sub

    Private Sub btnIE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIE.Click
        Shell("C:\Program Files\Internet Explorer\IEXPLORE.EXE " & OpenPath)
    End Sub

    Private Sub DateAndTimeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DateAndTimeToolStripMenuItem.Click
        TextBox1.AppendText(Date.Today & " " & TimeOfDay)
    End Sub

    Private Sub FileMD5ChecksumToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FileMD5ChecksumToolStripMenuItem.Click
        Me.Cursor = Cursors.WaitCursor
        'Open File Dialog
        Dim openFile As New OpenFileDialog()
        openFile.Filter = "All Files| *.*"
        openFile.InitialDirectory = True
        If openFile.ShowDialog() = DialogResult.OK Then
            'Do the cryptography hashing
            TextBox1.AppendText(u.GetMD5(openFile.FileName))
        Else
        End If
        Me.Cursor = Cursors.Default
    End Sub

    Private Sub btnFF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFF.Click
        MsgBox("""" & OpenPath.Replace(" ", "%20") & """")
        Shell(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Mozilla Firefox\firefox.exe " & """" & OpenPath.Replace(" ", "%20") & """")
    End Sub

    Private Sub btnGC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGC.Click
        Shell(System.Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) & "\Google\Chrome\Application\chrome.exe " & OpenPath.Replace(" ", "%20"))
    End Sub

    Private Sub btnOP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOP.Click
        Shell(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Opera\opera.exe" & """" & OpenPath.Replace(" ", "%20") & """")
    End Sub

    Private Sub btnAS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAS.Click
        Shell(My.Computer.FileSystem.SpecialDirectories.ProgramFiles & "\Safari\Safari.exe" & """" & OpenPath.Replace(" ", "%20") & """")
    End Sub

    Private Sub ReplaceToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReplaceToolStripMenuItem.Click
        frmReplace.ShowDialog()
    End Sub
    Public Sub save_temp_file()
        If TextBox1.Lines.Count < 500 Then
            Dim TargetFile As IO.StreamWriter
            Dim bytes() As Byte = System.Text.Encoding.UTF8.GetBytes(Date.Today & TimeOfDay)
            Dim tempfile As String = My.Computer.FileSystem.SpecialDirectories.Temp & "\notepad_backup.tmp"
            'Delete the previous temp file
            Try
                My.Computer.FileSystem.DeleteFile(tempfile)
            Catch ex As Exception

            End Try
            Try
                TargetFile = New IO.StreamWriter(tempfile, True)
            Catch
                Exit Sub
            End Try
            Try
                TargetFile.Write(TextBox1.Text)
            Catch
                Exit Sub
            End Try
            TargetFile.Close()
        End If
    End Sub

    Private Sub AlwaysOnTop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AlwaysOnTop.Click
        If AlwaysOnTop.Checked = True Then
            AlwaysOnTop.Checked = False
            Me.TopMost = False
        Else
            Me.TopMost = True
            AlwaysOnTop.Checked = True
        End If
    End Sub

    Private Sub ForceRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ForceRefresh.Click
        If ForceRefresh.Checked = True Then
            ForceRefresh.Checked = False
        Else
            ForceRefresh.Checked = True
        End If
    End Sub

    Private Sub ListToArrayToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListToArrayToolStripMenuItem.Click
        Call save_temp_file()
        List2Array.ShowDialog()
    End Sub
End Class
